diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/table-based-error-rate-model.cc ns-3.43/src/wifi/model/table-based-error-rate-model.cc
--- ns-3.42/src/wifi/model/table-based-error-rate-model.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/table-based-error-rate-model.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rohan Patidar <rpatidar@uw.edu>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -76,11 +65,11 @@
     m_fallbackErrorModel = nullptr;
 }
 
-double
-TableBasedErrorRateModel::RoundSnr(double snr, double precision) const
+dB_u
+TableBasedErrorRateModel::RoundSnr(dB_u snr, double precision) const
 {
     NS_LOG_FUNCTION(this << snr);
-    double multiplier = std::round(std::pow(10.0, precision));
+    const auto multiplier = std::round(std::pow(10.0, precision));
     return std::floor(snr * multiplier + 0.5) / multiplier;
 }
 
@@ -156,8 +145,8 @@
                                                 uint16_t staId) const
 {
     NS_LOG_FUNCTION(this << mode << txVector << snr << nbits << +numRxAntennas << field << staId);
-    uint64_t size = std::max<uint64_t>(1, (nbits / 8));
-    double roundedSnr = RoundSnr(RatioToDb(snr), SNR_PRECISION);
+    const auto size = std::max<uint64_t>(1, (nbits / 8)); // in bytes
+    const auto roundedSnr = RoundSnr(RatioToDb(snr), SNR_PRECISION);
     uint8_t mcs;
     if (auto ret = GetMcsForMode(mode); ret.has_value())
     {
@@ -189,13 +178,12 @@
     auto errorTable = (ldpc ? AwgnErrorTableLdpc1458
                             : (size < m_threshold ? AwgnErrorTableBcc32 : AwgnErrorTableBcc1458));
     const auto& itVector = errorTable[mcs];
-    auto itTable = std::find_if(itVector.cbegin(),
-                                itVector.cend(),
-                                [&roundedSnr](const std::pair<double, double>& element) {
-                                    return element.first == roundedSnr;
-                                });
-    double minSnr = itVector.cbegin()->first;
-    double maxSnr = (--itVector.cend())->first;
+    auto itTable =
+        std::find_if(itVector.cbegin(), itVector.cend(), [&roundedSnr](const auto& element) {
+            return element.first == roundedSnr;
+        });
+    const auto minSnr = itVector.cbegin()->first;
+    const auto maxSnr = (--itVector.cend())->first;
     double per;
     if (itTable == itVector.cend())
     {
@@ -211,8 +199,8 @@
         {
             double a = 0.0;
             double b = 0.0;
-            double previousSnr = 0.0;
-            double nextSnr = 0.0;
+            dB_u previousSnr{0.0};
+            dB_u nextSnr{0.0};
             for (auto i = itVector.cbegin(); i != itVector.cend(); ++i)
             {
                 if (i->first < roundedSnr)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/table-based-error-rate-model.h ns-3.43/src/wifi/model/table-based-error-rate-model.h
--- ns-3.42/src/wifi/model/table-based-error-rate-model.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/table-based-error-rate-model.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rohan Patidar <rpatidar@uw.edu>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -67,13 +56,13 @@
                                  uint16_t staId) const override;
 
     /**
-     * Round SNR (in dB) to the specified precision
+     * Round SNR to the specified precision
      *
-     * \param snr the SNR to round  (in dB)
+     * \param snr the SNR to round
      * \param precision the precision to use
-     * \return the rounded SNR (in dB) to the specified precision
+     * \return the rounded SNR to the specified precision
      */
-    double RoundSnr(double snr, double precision) const;
+    dB_u RoundSnr(dB_u snr, double precision) const;
 
     /**
      * Fetch the frame success rate for a given Wi-Fi mode, TXVECTOR, SNR and frame size.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/threshold-preamble-detection-model.cc ns-3.43/src/wifi/model/threshold-preamble-detection-model.cc
--- ns-3.42/src/wifi/model/threshold-preamble-detection-model.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/threshold-preamble-detection-model.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -44,12 +33,12 @@
                           "(expressed in dB).",
                           DoubleValue(4),
                           MakeDoubleAccessor(&ThresholdPreambleDetectionModel::m_threshold),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<dB_u>())
             .AddAttribute("MinimumRssi",
                           "Preamble is dropped if the RSSI is below this value (expressed in dBm).",
                           DoubleValue(-82),
                           MakeDoubleAccessor(&ThresholdPreambleDetectionModel::m_rssiMin),
-                          MakeDoubleChecker<double>());
+                          MakeDoubleChecker<dBm_u>());
     return tid;
 }
 
@@ -64,12 +53,12 @@
 }
 
 bool
-ThresholdPreambleDetectionModel::IsPreambleDetected(double rssi,
+ThresholdPreambleDetectionModel::IsPreambleDetected(dBm_u rssi,
                                                     double snr,
-                                                    double channelWidth) const
+                                                    MHz_u channelWidth) const
 {
-    NS_LOG_FUNCTION(this << WToDbm(rssi) << RatioToDb(snr) << channelWidth);
-    if (WToDbm(rssi) >= m_rssiMin)
+    NS_LOG_FUNCTION(this << rssi << RatioToDb(snr) << channelWidth);
+    if (rssi >= m_rssiMin)
     {
         if (RatioToDb(snr) >= m_threshold)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/threshold-preamble-detection-model.h ns-3.43/src/wifi/model/threshold-preamble-detection-model.h
--- ns-3.42/src/wifi/model/threshold-preamble-detection-model.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/threshold-preamble-detection-model.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -21,6 +10,7 @@
 #define THRESHOLD_PREAMBLE_DETECTION_MODEL_H
 
 #include "preamble-detection-model.h"
+#include "wifi-units.h"
 
 namespace ns3
 {
@@ -43,23 +33,11 @@
 
     ThresholdPreambleDetectionModel();
     ~ThresholdPreambleDetectionModel() override;
-
-    /**
-     * This method returns whether the preamble detection was successful.
-     *
-     * \param rssi the RSSI of the received signal (in Watts).
-     * \param snr the SNR ratio (linear scale) of the received signal.
-     * \param channelWidth the channel width of the received signal in MHz.
-     *
-     * \return true if the preamble has been detected,
-     *         false otherwise
-     */
-    bool IsPreambleDetected(double rssi, double snr, double channelWidth) const override;
+    bool IsPreambleDetected(dBm_u rssi, double snr, MHz_u channelWidth) const override;
 
   private:
-    double m_threshold; ///< SNR threshold in dB used to decide whether a preamble is successfully
-                        ///< received
-    double m_rssiMin;   ///< Minimum RSSI in dBm that shall be received to start the decision
+    dB_u m_threshold; ///< SNR threshold used to decide whether a preamble is successfully received
+    dBm_u m_rssiMin;  ///< Minimum RSSI that shall be received to start the decision
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/tim.cc ns-3.43/src/wifi/model/tim.cc
--- ns-3.42/src/wifi/model/tim.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/tim.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Davide Magrin <davide@magr.in>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/tim.h ns-3.43/src/wifi/model/tim.h
--- ns-3.42/src/wifi/model/tim.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/tim.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Davide Magrin <davide@magr.in>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/txop.cc ns-3.43/src/wifi/model/txop.cc
--- ns-3.42/src/wifi/model/txop.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/txop.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -620,16 +609,6 @@
 }
 
 void
-Txop::Queue(Ptr<Packet> packet, const WifiMacHeader& hdr)
-{
-    NS_LOG_FUNCTION(this << packet << &hdr);
-    // remove the priority tag attached, if any
-    SocketPriorityTag priorityTag;
-    packet->RemovePacketTag(priorityTag);
-    Queue(Create<WifiMpdu>(packet, hdr));
-}
-
-void
 Txop::Queue(Ptr<WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/txop.h ns-3.43/src/wifi/model/txop.h
--- ns-3.42/src/wifi/model/txop.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/txop.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -55,29 +44,14 @@
 enum WifiMacDropReason : uint8_t; // opaque enum declaration
 
 /**
- * \brief Handle packet fragmentation and retransmissions
- * for data and management frames.
+ * \brief Handles the packet queue and stores DCF/EDCA access parameters
+ * (one Txop per AC).
  * \ingroup wifi
  *
- * This class implements the packet fragmentation and
- * retransmission policy for data and management frames.
- * It uses the ns3::ChannelAccessManager helper
- * class to decide when to send a packet.
- * Packets are stored in a ns3::WifiMacQueue
- * until they can be sent.
- *
- * The policy currently implemented uses a simple fragmentation
- * threshold: any packet bigger than this threshold is fragmented
- * in fragments whose size is smaller than the threshold.
- *
- * The retransmission policy is also very simple: every packet is
- * retransmitted until it is either successfully transmitted or
- * it has been retransmitted up until the SSRC or SLRC thresholds.
- *
- * The RTS/CTS policy is similar to the fragmentation policy: when
- * a packet is bigger than a threshold, the RTS/CTS protocol is used.
+ * This class handles the packet queue and stores DCF/EDCA access
+ * parameters (one Txop per AC). It generates backoff values and stores the channel access status
+ * (not requested, requested, granted) for the corresponding DCF/EDCA and for each link.
  */
-
 class Txop : public Object
 {
   public:
@@ -354,14 +328,6 @@
 
     /* Event handlers */
     /**
-     * \param packet packet to send.
-     * \param hdr header of packet to send.
-     *
-     * Store the packet in the internal queue until it
-     * can be sent safely.
-     */
-    virtual void Queue(Ptr<Packet> packet, const WifiMacHeader& hdr);
-    /**
      * \param mpdu the given MPDU
      *
      * Store the given MPDU in the internal queue until it
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-capabilities.cc ns-3.43/src/wifi/model/vht/vht-capabilities.cc
--- ns-3.42/src/wifi/model/vht/vht-capabilities.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-capabilities.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@rim.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-capabilities.h ns-3.43/src/wifi/model/vht/vht-capabilities.h
--- ns-3.42/src/wifi/model/vht/vht-capabilities.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-capabilities.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@gmail.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-configuration.cc ns-3.43/src/wifi/model/vht/vht-configuration.cc
--- ns-3.42/src/wifi/model/vht/vht-configuration.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-configuration.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018  Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -70,9 +59,9 @@
                               &VhtConfiguration::SetSecondaryCcaSensitivityThresholds,
                               &VhtConfiguration::GetSecondaryCcaSensitivityThresholds),
                           MakeTupleChecker<DoubleValue, DoubleValue, DoubleValue>(
-                              MakeDoubleChecker<double>(),
-                              MakeDoubleChecker<double>(),
-                              MakeDoubleChecker<double>()));
+                              MakeDoubleChecker<dBm_u>(),
+                              MakeDoubleChecker<dBm_u>(),
+                              MakeDoubleChecker<dBm_u>()));
     return tid;
 }
 
@@ -107,7 +96,7 @@
             m_secondaryCcaSensitivityThresholds.at(80)};
 }
 
-const std::map<uint16_t, double>&
+const std::map<MHz_u, dBm_u>&
 VhtConfiguration::GetSecondaryCcaSensitivityThresholdsPerBw() const
 {
     return m_secondaryCcaSensitivityThresholds;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-configuration.h ns-3.43/src/wifi/model/vht/vht-configuration.h
--- ns-3.42/src/wifi/model/vht/vht-configuration.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-configuration.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018  Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -21,6 +10,7 @@
 #define VHT_CONFIGURATION_H
 
 #include "ns3/object.h"
+#include "ns3/wifi-units.h"
 
 #include <map>
 #include <tuple>
@@ -62,8 +52,8 @@
     bool Get160MHzOperationSupported() const;
 
     using SecondaryCcaSensitivityThresholds =
-        std::tuple<double, double, double>; //!< Tuple identifying CCA sensitivity thresholds for
-                                            //!< secondary channels
+        std::tuple<dBm_u, dBm_u, dBm_u>; //!< Tuple identifying CCA sensitivity thresholds for
+                                         //!< secondary channels
 
     /**
      * Sets the CCA sensitivity thresholds for PPDUs that do not occupy the primary channel.
@@ -80,16 +70,16 @@
 
     /**
      * \return the CCA sensitivity thresholds for PPDUs that do not occupy the primary channel,
-     * indexed by signal bandwidth (MHz)
+     * indexed by signal bandwidth
      */
-    const std::map<uint16_t, double>& GetSecondaryCcaSensitivityThresholdsPerBw() const;
+    const std::map<MHz_u, dBm_u>& GetSecondaryCcaSensitivityThresholdsPerBw() const;
 
   private:
     bool m_160MHzSupported; ///< whether 160 MHz operation is supported
-    std::map<uint16_t, double>
+    std::map<MHz_u, dBm_u>
         m_secondaryCcaSensitivityThresholds; ///< CCA sensitivity thresholds for signals that do not
                                              ///< occupy the primary channel, indexed by signal
-                                             ///< bandwidth (MHz)
+                                             ///< bandwidth
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.cc ns-3.43/src/wifi/model/vht/vht-frame-exchange-manager.cc
--- ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-frame-exchange-manager.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.h ns-3.43/src/wifi/model/vht/vht-frame-exchange-manager.h
--- ns-3.42/src/wifi/model/vht/vht-frame-exchange-manager.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-frame-exchange-manager.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-operation.cc ns-3.43/src/wifi/model/vht/vht-operation.cc
--- ns-3.42/src/wifi/model/vht/vht-operation.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-operation.cc	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/vht/vht-operation.h ns-3.43/src/wifi/model/vht/vht-operation.h
--- ns-3.42/src/wifi/model/vht/vht-operation.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/vht/vht-operation.h	2024-10-09 16:41:10.128656900 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
